diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/bindings/modulegen__gcc_LP64.py ns-3.32/src/applications/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/applications/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -10778,27 +10797,27 @@
     cls.add_method('AddressBlockDeserialize', 
                    'ns3::Ptr< ns3::PbbAddressBlock >', 
                    [param('ns3::Buffer::Iterator &', 'start')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): ns3::Address ns3::PbbMessageIpv4::DeserializeOriginatorAddress(ns3::Buffer::Iterator & start) const [member function]
     cls.add_method('DeserializeOriginatorAddress', 
                    'ns3::Address', 
                    [param('ns3::Buffer::Iterator &', 'start')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): ns3::PbbAddressLength ns3::PbbMessageIpv4::GetAddressLength() const [member function]
     cls.add_method('GetAddressLength', 
                    'ns3::PbbAddressLength', 
                    [], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): void ns3::PbbMessageIpv4::PrintOriginatorAddress(std::ostream & os) const [member function]
     cls.add_method('PrintOriginatorAddress', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): void ns3::PbbMessageIpv4::SerializeOriginatorAddress(ns3::Buffer::Iterator & start) const [member function]
     cls.add_method('SerializeOriginatorAddress', 
                    'void', 
                    [param('ns3::Buffer::Iterator &', 'start')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     return
 
 def register_Ns3PbbMessageIpv6_methods(root_module, cls):
@@ -10810,27 +10829,27 @@
     cls.add_method('AddressBlockDeserialize', 
                    'ns3::Ptr< ns3::PbbAddressBlock >', 
                    [param('ns3::Buffer::Iterator &', 'start')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): ns3::Address ns3::PbbMessageIpv6::DeserializeOriginatorAddress(ns3::Buffer::Iterator & start) const [member function]
     cls.add_method('DeserializeOriginatorAddress', 
                    'ns3::Address', 
                    [param('ns3::Buffer::Iterator &', 'start')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): ns3::PbbAddressLength ns3::PbbMessageIpv6::GetAddressLength() const [member function]
     cls.add_method('GetAddressLength', 
                    'ns3::PbbAddressLength', 
                    [], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): void ns3::PbbMessageIpv6::PrintOriginatorAddress(std::ostream & os) const [member function]
     cls.add_method('PrintOriginatorAddress', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     ## packetbb.h (module 'network'): void ns3::PbbMessageIpv6::SerializeOriginatorAddress(ns3::Buffer::Iterator & start) const [member function]
     cls.add_method('SerializeOriginatorAddress', 
                    'void', 
                    [param('ns3::Buffer::Iterator &', 'start')], 
-                   is_virtual=True, visibility='protected', is_const=True)
+                   visibility='protected', is_virtual=True, is_const=True)
     return
 
 def register_Ns3PbbPacket_methods(root_module, cls):
@@ -11162,12 +11181,12 @@
     cls.add_method('ConnectByObject', 
                    'bool', 
                    [param('std::string', 'traceSource'), param('ns3::Ptr< ns3::Object >', 'obj')], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## probe.h (module 'stats'): void ns3::Probe::ConnectByPath(std::string path) [member function]
     cls.add_method('ConnectByPath', 
                    'void', 
                    [param('std::string', 'path')], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## probe.h (module 'stats'): static ns3::TypeId ns3::Probe::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -11192,22 +11211,22 @@
     cls.add_method('Enqueue', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'item')], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Queue<ns3::Packet>::Dequeue() [member function]
     cls.add_method('Dequeue', 
                    'ns3::Ptr< ns3::Packet >', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Queue<ns3::Packet>::Remove() [member function]
     cls.add_method('Remove', 
                    'ns3::Ptr< ns3::Packet >', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<const ns3::Packet> ns3::Queue<ns3::Packet>::Peek() const [member function]
     cls.add_method('Peek', 
                    'ns3::Ptr< ns3::Packet const >', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True, is_const=True)
+                   is_virtual=True, is_const=True, is_pure_virtual=True)
     ## queue.h (module 'network'): void ns3::Queue<ns3::Packet>::Flush() [member function]
     cls.add_method('Flush', 
                    'void', 
@@ -11278,22 +11297,22 @@
     cls.add_method('Enqueue', 
                    'bool', 
                    [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::QueueDiscItem> ns3::Queue<ns3::QueueDiscItem>::Dequeue() [member function]
     cls.add_method('Dequeue', 
                    'ns3::Ptr< ns3::QueueDiscItem >', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::QueueDiscItem> ns3::Queue<ns3::QueueDiscItem>::Remove() [member function]
     cls.add_method('Remove', 
                    'ns3::Ptr< ns3::QueueDiscItem >', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<const ns3::QueueDiscItem> ns3::Queue<ns3::QueueDiscItem>::Peek() const [member function]
     cls.add_method('Peek', 
                    'ns3::Ptr< ns3::QueueDiscItem const >', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True, is_const=True)
+                   is_virtual=True, is_const=True, is_pure_virtual=True)
     ## queue.h (module 'network'): void ns3::Queue<ns3::QueueDiscItem>::Flush() [member function]
     cls.add_method('Flush', 
                    'void', 
@@ -13036,7 +13055,7 @@
     cls.add_method('AddHeader', 
                    'void', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue-item.h (module 'network'): void ns3::QueueDiscItem::Print(std::ostream & os) const [member function]
     cls.add_method('Print', 
                    'void', 
@@ -13046,7 +13065,7 @@
     cls.add_method('Mark', 
                    'bool', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## queue-item.h (module 'network'): uint32_t ns3::QueueDiscItem::Hash(uint32_t perturbation=0) const [member function]
     cls.add_method('Hash', 
                    'uint32_t', 
@@ -13063,7 +13082,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -13073,7 +13092,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_virtual=True, is_pure_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/bulk-send-application.cc ns-3.32/src/applications/model/bulk-send-application.cc
--- ns-3.31/src/applications/model/bulk-send-application.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/bulk-send-application.cc	2020-10-06 15:35:43.000000000 -0700
@@ -226,6 +226,7 @@
       if (m_unsentPacket)
         {
           packet = m_unsentPacket;
+          toSend = packet->GetSize ();
         }
       else if (m_enableSeqTsSizeHeader)
         {
@@ -259,6 +260,19 @@
           m_unsentPacket = packet;
           break;
         }
+      else if (actual > 0 && (unsigned) actual < toSend)
+        {
+          // A Linux socket (non-blocking, such as in DCE) may return
+          // a quantity less than the packet size.  Split the packet
+          // into two, trace the sent packet, save the unsent packet
+          NS_LOG_DEBUG ("Packet size: " << packet->GetSize () << "; sent: " << actual << "; fragment saved: " << toSend - (unsigned) actual);
+          Ptr<Packet> sent = packet->CreateFragment (0, actual);
+          Ptr<Packet> unsent = packet->CreateFragment (actual, (toSend - (unsigned) actual));
+          m_totBytes += actual;
+          m_txTrace (sent);
+          m_unsentPacket = unsent;
+          break;
+        }
       else
         {
           NS_FATAL_ERROR ("Unexpected return value from m_socket->Send ()");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/onoff-application.cc ns-3.32/src/applications/model/onoff-application.cc
--- ns-3.31/src/applications/model/onoff-application.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/onoff-application.cc	2020-10-06 15:35:43.000000000 -0700
@@ -292,7 +292,6 @@
   else
     { // All done, cancel any pending events
       StopApplication ();
-      exit(1);
     }
 }
 
@@ -355,8 +354,8 @@
       m_socket->GetSockName (localAddress);
       if (InetSocketAddress::IsMatchingType (m_peer))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                       << "s on-off application sent "
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S)
+                       << " on-off application sent "
                        <<  packet->GetSize () << " bytes to "
                        << InetSocketAddress::ConvertFrom(m_peer).GetIpv4 ()
                        << " port " << InetSocketAddress::ConvertFrom (m_peer).GetPort ()
@@ -365,8 +364,8 @@
         }
       else if (Inet6SocketAddress::IsMatchingType (m_peer))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                       << "s on-off application sent "
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S)
+                       << " on-off application sent "
                        <<  packet->GetSize () << " bytes to "
                        << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6 ()
                        << " port " << Inet6SocketAddress::ConvertFrom (m_peer).GetPort ()
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/packet-sink.cc ns-3.32/src/applications/model/packet-sink.cc
--- ns-3.31/src/applications/model/packet-sink.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/packet-sink.cc	2020-10-06 15:35:43.000000000 -0700
@@ -188,8 +188,8 @@
       m_totalRx += packet->GetSize ();
       if (InetSocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                       << "s packet sink received "
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S)
+                       << " packet sink received "
                        <<  packet->GetSize () << " bytes from "
                        << InetSocketAddress::ConvertFrom(from).GetIpv4 ()
                        << " port " << InetSocketAddress::ConvertFrom (from).GetPort ()
@@ -197,8 +197,8 @@
         }
       else if (Inet6SocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                       << "s packet sink received "
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S)
+                       << " packet sink received "
                        <<  packet->GetSize () << " bytes from "
                        << Inet6SocketAddress::ConvertFrom(from).GetIpv6 ()
                        << " port " << Inet6SocketAddress::ConvertFrom (from).GetPort ()
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/seq-ts-header.cc ns-3.32/src/applications/model/seq-ts-header.cc
--- ns-3.31/src/applications/model/seq-ts-header.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/seq-ts-header.cc	2020-10-06 15:35:43.000000000 -0700
@@ -76,7 +76,7 @@
 SeqTsHeader::Print (std::ostream &os) const
 {
   NS_LOG_FUNCTION (this << &os);
-  os << "(seq=" << m_seq << " time=" << TimeStep (m_ts).GetSeconds () << ")";
+  os << "(seq=" << m_seq << " time=" << TimeStep (m_ts).As (Time::S) << ")";
 }
 uint32_t
 SeqTsHeader::GetSerializedSize (void) const
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/three-gpp-http-client.cc ns-3.32/src/applications/model/three-gpp-http-client.cc
--- ns-3.31/src/applications/model/three-gpp-http-client.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/three-gpp-http-client.cc	2020-10-06 15:35:43.000000000 -0700
@@ -741,7 +741,7 @@
       const Time parsingTime = m_httpVariables->GetParsingTime ();
       NS_LOG_INFO (this << " The parsing of this main object"
                         << " will complete in "
-                        << parsingTime.GetSeconds () << " seconds.");
+                        << parsingTime.As (Time::S) << ".");
       m_eventParseMainObject = Simulator::Schedule (
           parsingTime, &ThreeGppHttpClient::ParseMainObject, this);
       SwitchToState (PARSING_MAIN_OBJECT);
@@ -804,7 +804,7 @@
     {
       const Time readingTime = m_httpVariables->GetReadingTime ();
       NS_LOG_INFO (this << " Client will finish reading this web page in "
-                        << readingTime.GetSeconds () << " seconds.");
+                        << readingTime.As (Time::S) << ".");
 
       // Schedule a request of another main object once the reading time expires.
       m_eventRequestMainObject = Simulator::Schedule (
@@ -827,24 +827,24 @@
   if (!Simulator::IsExpired (m_eventRequestMainObject))
     {
       NS_LOG_INFO (this << " Canceling RequestMainObject() which is due in "
-                        << Simulator::GetDelayLeft (m_eventRequestMainObject).GetSeconds ()
-                        << " seconds.");
+                        << Simulator::GetDelayLeft (m_eventRequestMainObject).As (Time::S)
+                        << ".");
       Simulator::Cancel (m_eventRequestMainObject);
     }
 
   if (!Simulator::IsExpired (m_eventRequestEmbeddedObject))
     {
       NS_LOG_INFO (this << " Canceling RequestEmbeddedObject() which is due in "
-                        << Simulator::GetDelayLeft (m_eventRequestEmbeddedObject).GetSeconds ()
-                        << " seconds.");
+                        << Simulator::GetDelayLeft (m_eventRequestEmbeddedObject).As (Time::S)
+                        << ".");
       Simulator::Cancel (m_eventRequestEmbeddedObject);
     }
 
   if (!Simulator::IsExpired (m_eventParseMainObject))
     {
       NS_LOG_INFO (this << " Canceling ParseMainObject() which is due in "
-                        << Simulator::GetDelayLeft (m_eventParseMainObject).GetSeconds ()
-                        << " seconds.");
+                        << Simulator::GetDelayLeft (m_eventParseMainObject).As (Time::S)
+                        << ".");
       Simulator::Cancel (m_eventParseMainObject);
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/three-gpp-http-header.cc ns-3.32/src/applications/model/three-gpp-http-header.cc
--- ns-3.31/src/applications/model/three-gpp-http-header.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/three-gpp-http-header.cc	2020-10-06 15:35:43.000000000 -0700
@@ -110,8 +110,8 @@
   NS_LOG_FUNCTION (this << &os);
   os << "(Content-Type: " << m_contentType
      << " Content-Length: " << m_contentLength
-     << " Client TS: " << TimeStep (m_clientTs).GetSeconds ()
-     << " Server TS: " << TimeStep (m_serverTs).GetSeconds () << ")";
+     << " Client TS: " << TimeStep (m_clientTs).As (Time::S)
+     << " Server TS: " << TimeStep (m_serverTs).As (Time::S) << ")";
 }
 
 
@@ -188,7 +188,7 @@
 void
 ThreeGppHttpHeader::SetClientTs (Time clientTs)
 {
-  NS_LOG_FUNCTION (this << clientTs.GetSeconds ());
+  NS_LOG_FUNCTION (this << clientTs.As (Time::S));
   m_clientTs = clientTs.GetTimeStep ();
 }
 
@@ -203,7 +203,7 @@
 void
 ThreeGppHttpHeader::SetServerTs (Time serverTs)
 {
-  NS_LOG_FUNCTION (this << serverTs.GetSeconds ());
+  NS_LOG_FUNCTION (this << serverTs.As (Time::S));
   m_serverTs = serverTs.GetTimeStep ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/three-gpp-http-server.cc ns-3.32/src/applications/model/three-gpp-http-server.cc
--- ns-3.31/src/applications/model/three-gpp-http-server.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/three-gpp-http-server.cc	2020-10-06 15:35:43.000000000 -0700
@@ -455,7 +455,7 @@
         case ThreeGppHttpHeader::MAIN_OBJECT:
           processingDelay = m_httpVariables->GetMainObjectGenerationDelay ();
           NS_LOG_INFO (this << " Will finish generating a main object"
-                            << " in " << processingDelay.GetSeconds () << " seconds.");
+                            << " in " << processingDelay.As (Time::S) << ".");
           m_txBuffer->RecordNextServe (socket,
                                        Simulator::Schedule (processingDelay,
                                                             &ThreeGppHttpServer::ServeNewMainObject,
@@ -466,7 +466,7 @@
         case ThreeGppHttpHeader::EMBEDDED_OBJECT:
           processingDelay = m_httpVariables->GetEmbeddedObjectGenerationDelay ();
           NS_LOG_INFO (this << " Will finish generating an embedded object"
-                            << " in " << processingDelay.GetSeconds () << " seconds.");
+                            << " in " << processingDelay.As (Time::S) << ".");
           m_txBuffer->RecordNextServe (socket,
                                        Simulator::Schedule (processingDelay,
                                                             &ThreeGppHttpServer::ServeNewEmbeddedObject,
@@ -635,8 +635,8 @@
       NS_LOG_INFO (this << " Created packet " << packet << " of "
                         << packetSize << " bytes."
                         << " The corresponding request came "
-                        << (Simulator::Now () - httpHeader.GetClientTs ()).GetSeconds ()
-                        << "s ago.");
+                        << (Simulator::Now () - httpHeader.GetClientTs ()).As (Time::S)
+                        << " ago.");
     }
   else
     {
@@ -731,8 +731,8 @@
   if (!Simulator::IsExpired (it->second.nextServe))
     {
       NS_LOG_INFO (this << " Canceling a serving event which is due in "
-                        << Simulator::GetDelayLeft (it->second.nextServe).GetSeconds ()
-                        << " seconds.");
+                        << Simulator::GetDelayLeft (it->second.nextServe).As (Time::S)
+                        << ".");
       Simulator::Cancel (it->second.nextServe);
     }
 
@@ -758,8 +758,8 @@
   if (!Simulator::IsExpired (it->second.nextServe))
     {
       NS_LOG_INFO (this << " Canceling a serving event which is due in "
-                        << Simulator::GetDelayLeft (it->second.nextServe).GetSeconds ()
-                        << " seconds.");
+                        << Simulator::GetDelayLeft (it->second.nextServe).As (Time::S)
+                        << ".");
       Simulator::Cancel (it->second.nextServe);
     }
 
@@ -791,8 +791,8 @@
       if (!Simulator::IsExpired (it->second.nextServe))
         {
           NS_LOG_INFO (this << " Canceling a serving event which is due in "
-                            << Simulator::GetDelayLeft (it->second.nextServe).GetSeconds ()
-                            << " seconds.");
+                            << Simulator::GetDelayLeft (it->second.nextServe).As (Time::S)
+                            << ".");
           Simulator::Cancel (it->second.nextServe);
         }
 
@@ -892,7 +892,7 @@
                                              const EventId  &eventId,
                                              const Time     &clientTs)
 {
-  NS_LOG_FUNCTION (this << socket << clientTs.GetSeconds ());
+  NS_LOG_FUNCTION (this << socket << clientTs.As (Time::S));
 
   std::map<Ptr<Socket>, TxBuffer_t>::iterator it;
   it = m_txBuffer.find (socket);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/three-gpp-http-variables.cc ns-3.32/src/applications/model/three-gpp-http-variables.cc
--- ns-3.31/src/applications/model/three-gpp-http-variables.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/three-gpp-http-variables.cc	2020-10-06 15:35:43.000000000 -0700
@@ -362,7 +362,7 @@
 void
 ThreeGppHttpVariables::SetMainObjectGenerationDelay (Time constant)
 {
-  NS_LOG_FUNCTION (this << constant.GetSeconds ());
+  NS_LOG_FUNCTION (this << constant.As (Time::S));
   m_mainObjectGenerationDelayRng->SetAttribute ("Constant",
                                                 DoubleValue (constant.GetSeconds ()));
 }
@@ -425,7 +425,7 @@
 void
 ThreeGppHttpVariables::SetEmbeddedObjectGenerationDelay (Time constant)
 {
-  NS_LOG_FUNCTION (this << constant.GetSeconds ());
+  NS_LOG_FUNCTION (this << constant.As (Time::S));
   m_embeddedObjectGenerationDelayRng->SetAttribute ("Constant",
                                                     DoubleValue (constant.GetSeconds ()));
 }
@@ -490,7 +490,7 @@
 void
 ThreeGppHttpVariables::SetReadingTimeMean (Time mean)
 {
-  NS_LOG_FUNCTION (this << mean.GetSeconds ());
+  NS_LOG_FUNCTION (this << mean.As (Time::S));
   m_readingTimeRng->SetAttribute ("Mean", DoubleValue (mean.GetSeconds ()));
 }
 
@@ -498,7 +498,7 @@
 void
 ThreeGppHttpVariables::SetParsingTimeMean (Time mean)
 {
-  NS_LOG_FUNCTION (this << mean.GetSeconds ());
+  NS_LOG_FUNCTION (this << mean.As (Time::S));
   m_parsingTimeRng->SetAttribute ("Mean", DoubleValue (mean.GetSeconds ()));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/udp-client.cc ns-3.32/src/applications/model/udp-client.cc
--- ns-3.31/src/applications/model/udp-client.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/udp-client.cc	2020-10-06 15:35:43.000000000 -0700
@@ -193,7 +193,7 @@
       NS_LOG_INFO ("TraceDelay TX " << m_size << " bytes to "
                                     << peerAddressStringStream.str () << " Uid: "
                                     << p->GetUid () << " Time: "
-                                    << (Simulator::Now ()).GetSeconds ());
+                                    << (Simulator::Now ()).As (Time::S));
 
     }
   else
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/udp-echo-client.cc ns-3.32/src/applications/model/udp-echo-client.cc
--- ns-3.31/src/applications/model/udp-echo-client.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/udp-echo-client.cc	2020-10-06 15:35:43.000000000 -0700
@@ -351,22 +351,22 @@
 
   if (Ipv4Address::IsMatchingType (m_peerAddress))
     {
-      NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s client sent " << m_size << " bytes to " <<
+      NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " client sent " << m_size << " bytes to " <<
                    Ipv4Address::ConvertFrom (m_peerAddress) << " port " << m_peerPort);
     }
   else if (Ipv6Address::IsMatchingType (m_peerAddress))
     {
-      NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s client sent " << m_size << " bytes to " <<
+      NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " client sent " << m_size << " bytes to " <<
                    Ipv6Address::ConvertFrom (m_peerAddress) << " port " << m_peerPort);
     }
   else if (InetSocketAddress::IsMatchingType (m_peerAddress))
     {
-      NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s client sent " << m_size << " bytes to " <<
+      NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " client sent " << m_size << " bytes to " <<
                    InetSocketAddress::ConvertFrom (m_peerAddress).GetIpv4 () << " port " << InetSocketAddress::ConvertFrom (m_peerAddress).GetPort ());
     }
   else if (Inet6SocketAddress::IsMatchingType (m_peerAddress))
     {
-      NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s client sent " << m_size << " bytes to " <<
+      NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " client sent " << m_size << " bytes to " <<
                    Inet6SocketAddress::ConvertFrom (m_peerAddress).GetIpv6 () << " port " << Inet6SocketAddress::ConvertFrom (m_peerAddress).GetPort ());
     }
 
@@ -387,13 +387,13 @@
     {
       if (InetSocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s client received " << packet->GetSize () << " bytes from " <<
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " client received " << packet->GetSize () << " bytes from " <<
                        InetSocketAddress::ConvertFrom (from).GetIpv4 () << " port " <<
                        InetSocketAddress::ConvertFrom (from).GetPort ());
         }
       else if (Inet6SocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s client received " << packet->GetSize () << " bytes from " <<
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " client received " << packet->GetSize () << " bytes from " <<
                        Inet6SocketAddress::ConvertFrom (from).GetIpv6 () << " port " <<
                        Inet6SocketAddress::ConvertFrom (from).GetPort ());
         }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/applications/model/udp-echo-server.cc ns-3.32/src/applications/model/udp-echo-server.cc
--- ns-3.31/src/applications/model/udp-echo-server.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/applications/model/udp-echo-server.cc	2020-10-06 15:35:43.000000000 -0700
@@ -167,13 +167,13 @@
       m_rxTraceWithAddresses (packet, from, localAddress);
       if (InetSocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s server received " << packet->GetSize () << " bytes from " <<
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " server received " << packet->GetSize () << " bytes from " <<
                        InetSocketAddress::ConvertFrom (from).GetIpv4 () << " port " <<
                        InetSocketAddress::ConvertFrom (from).GetPort ());
         }
       else if (Inet6SocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s server received " << packet->GetSize () << " bytes from " <<
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " server received " << packet->GetSize () << " bytes from " <<
                        Inet6SocketAddress::ConvertFrom (from).GetIpv6 () << " port " <<
                        Inet6SocketAddress::ConvertFrom (from).GetPort ());
         }
@@ -186,13 +186,13 @@
 
       if (InetSocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s server sent " << packet->GetSize () << " bytes to " <<
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " server sent " << packet->GetSize () << " bytes to " <<
                        InetSocketAddress::ConvertFrom (from).GetIpv4 () << " port " <<
                        InetSocketAddress::ConvertFrom (from).GetPort ());
         }
       else if (Inet6SocketAddress::IsMatchingType (from))
         {
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds () << "s server sent " << packet->GetSize () << " bytes to " <<
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S) << " server sent " << packet->GetSize () << " bytes to " <<
                        Inet6SocketAddress::ConvertFrom (from).GetIpv6 () << " port " <<
                        Inet6SocketAddress::ConvertFrom (from).GetPort ());
         }
